<template>
  <div class="wrapper fadeInDown">
    <div id="overlay"  v-if="loading">
       <div class="spinner"></div>
       <br/>
       <h4>Logging In...</h4>
    </div>
    <Toast style="margin-top: 10px" />
   <div id="formContent">
    <!-- Tabs Titles -->
      <h2 class="active"> Sign In </h2>
      <!-- <router-link to="/inquiry"><h2 class="inactive underlineHover">Register </h2></router-link> -->

                <!-- Icon -->
      <div class="fadeIn first">
        <img src="static/img/gov-logo.png"  alt="logo" style="height: 50%;width: 20%;" />
      </div>
                <!-- Login Form -->
            <form id="loginForm"  method="post">
              <input type="text" id="uname" class="fadeIn second" v-model="username" placeholder="Enter your username">
              <input type="password" id="password" class="fadeIn third" v-model="password" placeholder="Enter your password">
              <input type="submit" class="fadeIn fourth" value="Log In" @click.prevent="checkCreds">
            </form>
                <!-- Remind Passowrd -->
                <!-- <div id="formFooter">
                    <span class="underlineHover">Powered by</span>
                    <span> <a href="https://raisetech.com.np" target="_blank"><img src="static/img/raiseTechlogo.png"  alt="Raiselogo" /></a> </span>
                </div> -->
            </div>
        </div>
</template>

<script>
import axios from 'axios'
import globalKey from '../store/globalKey'
import Toast from 'primevue/toast'
export default {
  name: 'Login',
  data(router) {
    return {
      section: 'Login',
      username: '',
      password: '',
      message: '',
      loading: false
    }
  },
  methods: {
    checkCreds() {
      const { username, password } = this
      const AUTH_URL = globalKey + '/auth'
      if (this.username.trim() === '' || this.password.trim() === '') {
        this.$toast.add({severity: 'error', summary: '', detail: 'Username and Password cannot be empty!', life: 10000})
        return
      }
      this.loading = !this.loading
      axios.post(AUTH_URL, { username, password })
        .then(response => {
          let data = response.data
          if (data.user) {
            this.$store.commit('SET_USER', data.user)
            const token = 'Bearer ' + data.access_token
            const organisationId = data.organisationId
            const fyId = data.fyId
            const startDate = data.startDate
            const expiry = data.expiry
            const modules = data.user.role.modules
            const englishDateExist = data.isEnglishDateEnabled
            const nepaliDate = data.nepaliNewDate
            const endDate = data.endDate
            const customerId = data.customerId
            // const warehouse = data.warehouseId
            // const counter = data.counterId
            const fyName = data.fyName
            const organisationAddress = data.organisationAddress
            const organisationName = data.organisationName
            const organisationContact = data.organisationContact
            const organisationLogo = data.organisationLogo
            const organisationPanVatNo = data.organisationPanVatNo
            this.$store.commit('SET_TOKEN', token)
            this.$store.commit('ORGANISATIONID', organisationId)
            this.$store.commit('FYID', fyId)
            this.$store.commit('STARTDATE', startDate)
            this.$store.commit('EXPIRY', expiry)
            this.$store.commit('MODULES', modules)
            this.$store.commit('ENGLISHDATEENABLED', englishDateExist)
            this.$store.commit('NEPALI_NEWDATE', nepaliDate)
            this.$store.commit('ENDDATE', endDate)
            this.$store.commit('CUSTOMERID', customerId)
            // this.$store.commit('SET_WAREHOUSE_DATA', warehouse)
            // this.$store.commit('SET_COUNTER_DATA', counter)
            this.$store.commit('FYNAME', fyName)
            this.$store.commit('ORGANISATIONAME', organisationName)
            this.$store.commit('ORGANISATIONADDRESS', organisationAddress)
            this.$store.commit('ORGANISATIONCONTACT', organisationContact)
            this.$store.commit('ORGANISATIONLOGO', organisationLogo)
            this.$store.commit('ORGANISATIONPANVATNO', organisationPanVatNo)
            if (window.localStorage) {
              window.localStorage.setItem('user', JSON.stringify(data.user))
              window.localStorage.setItem('token', token)
              window.localStorage.setItem('organisationId', organisationId)
              window.localStorage.setItem('fyId', fyId)
              window.localStorage.setItem('startDate', startDate)
              window.localStorage.setItem('expiry', expiry)
              window.localStorage.setItem('modules', modules)
              window.localStorage.setItem('englishDate', englishDateExist)
              window.localStorage.setItem('nepaliNewDate', nepaliDate)
              window.localStorage.setItem('endDate', endDate)
              window.localStorage.setItem('customerId', customerId)
              // window.localStorage.setItem('getWarehouse', JSON.stringify(data.warehouseId))
              // window.localStorage.setItem('getCounter', JSON.stringify(data.counterId))
              window.localStorage.setItem('fyName', fyName)
              window.localStorage.setItem('organisationName', organisationName)
              window.localStorage.setItem('organisationAddress', organisationAddress)
              window.localStorage.setItem('organisationContact', organisationContact)
              window.localStorage.setItem('organisationLogo', organisationLogo)
              window.localStorage.setItem('organisationPanVatNo', organisationPanVatNo)
            }
            this.$router.push(data.redirect ? data.redirect : '/')
          }
        })
        .catch(error => {
          if (error.response !== undefined) {
            if (error.response.status === 401) {
              this.loading = false
              window.localStorage.removeItem('token', this.token)
              this.$toast.add({severity: 'error', summary: '', detail: 'Invalid Username or Password!', life: 10000})
              // this.username = ''
              // this.password = ''
              this.$router.push('/')
              return
            }
          } else {
            window.localStorage.removeItem('token', this.token)
            this.loading = false
            this.$toast.add({severity: 'error', summary: '', detail: 'Server appears to be offline. Please consult with our support Team.!', life: 10000})
            return
          }
        })
    }
  },
  components: {
    Toast
  }
}
</script>

<style  scoped  src="@../../../static/css/loginpage.css">
#overlay {
      background: #ffffff;;
      color: #3c8dbc;
      position: fixed;
      height: 100%;
      width: 100%;
      z-index: 5000;
      top: 0;
      left: 0;
      float: left;
      text-align: center;
      padding-top: 25%;
      opacity: .80;
    }
    .spinner {
        margin: 0 auto;
        height: 64px;
        width: 64px;
        animation: rotate 0.8s infinite linear;
        border: 5px solid #3c8dbc;
        border-right-color: transparent;
        border-radius: 50%;
    }
    @keyframes rotate {
        0% {
            transform: rotate(0deg);
        }
        100% {
            transform: rotate(360deg);
        }
    }
</style>
